﻿using System;
using System.Collections.Generic;
using HeuristicLab.Services.Authentication.DataTransfer;
using System.ServiceModel;
using System.Net.Security;

namespace HeuristicLab.Services.Authentication
{
    [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
    public interface IAuthenticationService
    {
        #region User

        [OperationContract]
        User GetUser(Guid id);


        // IEnumerable<User> GetUsers();

        [OperationContract]
        IEnumerable<User> GetUsers(Guid applicationId);

        [OperationContract]
        Guid InsertUser(User user);         // => AddUser

        [OperationContract]
        bool DeleteUser(Guid id);

        [OperationContract]
        bool UpdateUser(User user);

        [OperationContract]
        bool AddUserToRole(Guid roleId, Guid userId);

        [OperationContract]
        bool RemoveUserFromRole(Guid roleId, Guid userId);

        [OperationContract]
        IEnumerable<Role> GetRolesForUser(Guid userId);  // returnvalue = GUID


      // IsUserInRole
      // 

        #endregion

        #region Role

        [OperationContract]
        Role GetRole(Guid id);


        //IEnumerable<Role> GetRoles();

        [OperationContract]
        IEnumerable<Role> GetRoles(Guid applicationId);

        [OperationContract]
        Guid InsertRole(Role role); // Add

        [OperationContract]
        bool UpdateRole(Role role);

        [OperationContract]
        bool DeleteRole(Guid id);

        [OperationContract]
        IEnumerable<User> GetUsersInRole(Guid roleId); // return = Guid

        #endregion

        #region Application

        [OperationContract]
        Application GetApplication(Guid id);

        [OperationContract]
        Guid InsertApplication(Application application); // ADD

        [OperationContract]
        bool DeleteApplication(Guid id);

        [OperationContract]
        IEnumerable<DataTransfer.Application> GetApplications();


        [OperationContract]
        bool UpdateApplication(Application application);

        #endregion

        
    }
}
